package com.javacodegeeks.dw.persistence;

import java.util.List;
import java.util.Optional;

import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Root;

import org.hibernate.SessionFactory;

import io.dropwizard.hibernate.AbstractDAO;

public class TaskRepository extends AbstractDAO<Task> {
    public TaskRepository(SessionFactory factory) {
        super(factory);
    }

    public Optional<Task> findById(Integer id) {
        return Optional.ofNullable(get(id));
    }

    public Task create(Task task) {
        return persist(task);
    }

    public List<Task> findAll() {
        final CriteriaQuery<Task> query = criteriaQuery();
        final Root<Task> root = query.from(Task.class); 
        return list(query.select(root));
    }
    
    public void deleteById(Integer id) {
        findById(id).ifPresent(currentSession()::remove);
    }
}
